#!/bin/bash
#
# File: /usr/local/bin/recursive
#
# work a command in actual dir and all subdirs
#
#    Copyright (C) 2013 Ingo Kaesmann
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
# Script template: 0.3.0
#
# Exit codes:
# 0 = OK
# 1 = Error in parameters
# 3 = Library old or not found
##############################################################################
# SOURCE FILES

. /usr/local/etc/main-inka-sh.conf			# main config
. $LLIBDIR/lib-inka-std.sh				# functions standard
#. /usr/local/etc/x.conf				# global config
#. ~/.$(basename $0)rc					# personal config
#. ~/.xrc						# local config
##############################################################################
# DECLARATION OF VARIABLES

# STRINGS
pkgname=inka-utilities					# package name for work
lib_inka_std_sh_needed=1.3.6				# standard lib version
conf_file_needed=0.0.0					# conf file version
#----------------------- end of variables to configure -----------------------
version=$(grep "^VERSION" $PROGREG/$pkgname.inf | cut -f 2)	# version
scriptname=$(basename $0)				# name of script
tempfile=$TEMPDIR/$scriptname.$UID.$$.tmp		# temporary file
infolog="logger -p user.info -t $scriptname --"		# log info messages
errlog="logger -p user.err -t $scriptname -- ERROR:"	# log error messages
debuglog="logger -p user.debug -t $scriptname -- DEBUG:" # log debug messages
debug=no						# debug=yes/no
verbose=""						# verbose=""/-q/-v
opt_found=no						# opt_found=yes/no
opt=""							# option
#------------------------- end of standard variables -------------------------
tempfile2=$TEMPDIR/$scriptname.$UID.2.tmp		# temporary file

# NUMBERS
err=0							# exit code

##############################################################################
# FUNCTIONS

function show_help ()
{
# Show help
# Uses: cat
# Return codes: standard

if [ "$debug" == "yes" ]; then				# debug
	echo "DEBUG show_help: $# $@" >&2
	#$debuglog show_help: $# $@
fi

cat <<EOT

Aufruf: $scriptname [OPTION]... 'BEFEHL [PARAMETER]...'
Einen Befehl im aktuellen Verzeichnis und allen Unterverzeichnissen ausfuehren

-h, --help      Hilfe anzeigen und beenden
 --version      Versionsinformationen anzeigen und beenden
   --debug      Debug-Modus benutzen
        -q      ohne Meldungen
        -v      mit Erklaerungen der Taetigkeiten

BEFEHL          auszufuehrender Befehl
PARAMETER       Parameter fuer auszufuehrenden Befehl

Befehl und Parameter zusammen in einfache Anfuehrungszeichen setzen!

EOT
return 0
}
#-----------------------------------------------------------------------------
function main_proc ()
{
# Command (with parameters) will work in aktual directory and subdirectories
# Par: command with all parameters
# Uses: cat, cd, chmod, cut, echo, grep, ls, pwd, rm, wc, Read_Lines
# Return codes: standard

local lastdir lastline line n
lastdir=""			# start dir
line=""				# line of list, every line is directory

lastline=0			# number of lines
n=0				# loop counter

if [ "$debug" == "yes" ]; then				# debug
	echo "DEBUG main_proc: $# $@" >&2
	$debuglog main_proc: $# $@
fi

echo "#!/bin/sh" > $tempfile2			# initial workscript
echo "$@" >> $tempfile2				# write command to workscript
chmod 700 $tempfile2				# make workscript executable

/bin/ls -1R | grep ":$" | cut -d ":" -f 1 > $tempfile	# build list of dirs
lastline=$(cat $tempfile | wc -l)			# number of lines
lastdir=$(pwd)						# start dir

n=0
while [ $n -lt $lastline ]; do				# begin of loop
	let n++
	line=$(Read_Lines $tempfile $n $n)		# read line
	if [ "$verbose" == "-v" ]; then
		echo "$line:"
	fi
	cd $line					# cd subdir
	$tempfile2					# work command
	cd $lastdir					# cd start dir
done							# end of loop

rm -f $tempfile $tempfile2
return 0
}
##############################################################################
# PARSE COMMANDLINE

# Read all options with args and all additional args into variables.
# Stop parsing after last parameter.
# Try to do a check on all parameters and version numbers.
# Handle options -h, --show-config and --version directly.
# Exit on error.

if [ "$debug" == "yes" ]; then				# debug
	echo "DEBUG Parse Commandline: $# $@" >&2
	#$debuglog Parse Commandline: $# $@
fi

# get options and options with arguments
while [ "${1:0:1}" == "-" ]; do				# get all options
	case "$1" in
	  -h|--help)	opt=-h;;			# option -h
	  --version)	opt=--v;; 			# option --version
#	  --show-config) opt=--s;;			# option --show-config
	  --debug)	debug=yes;;			# option --debug
	  -q|--quiet)	verbose=-q;;			# option -q
	  -v|--verbose)	verbose=-v;;			# option -v
#-------------------------- end of standard options --------------------------
	  *)	if [ "$verbose" != "-q" ]; then
			echo "Fehler - Option $1 falsch!" >&2	# error
		else
			$errlog unknown option $1
		fi
		exit 1;;
	esac
	shift
	opt_found=yes
done

# handle standard options -h, --v, --s
case "$opt" in
  -h)	show_help; exit 0;;					# show help
  --v)	echo "$scriptname (${pkgname}) $version"; exit 0;;	# show version
  --s)	show_config; exit 0;;					# show config
esac

# check library
Compare_Version $lib_inka_std_sh_needed $Lib_Inka_Std_Sh_Version
ret=$?						# (ret: 0,1,2,9,127)
if [ $ret -eq 1 ]; then				# needed lib-version higher than installed
	if [ "$verbose" != "-q" ]; then
		echo "Fehler - Programm benoetigt neuere Version von lib-inka-std.sh!" >&2
	else
		$errlog newer version of lib-inka-std.sh needed
	fi
	exit 3
elif [ $ret -eq 9 ] || [ $ret -eq 127 ]; then	# other error (version or lib missing)
	if [ "$verbose" != "-q" ]; then
		echo "Fehler - Versionspruefung von lib-inka-std.sh nicht moeglich!"
	else
		$errlog check of version of lib-inka-std.sh impossible
	fi
	exit 3
else						# check ok, reset $ret
	ret=0
fi

# check version of config files			# set config var!
#Compare_Version $conf_file_needed $Program_Conf
#Compare_Version $conf_file_needed $Program_Rc
ret=$?						# (ret: 0,1,2,9)
if [ $ret -eq 1 ]; then				# needed config-version higher than installed
	if [ "$verbose" != "-q" ]; then
		echo "Fehler - $scriptname benoetigt neuere Version der Konfig-datei!" >&2
	else
		$errlog newer version of conf file needed
	fi
	exit 2
elif [ $ret -eq 9 ]; then			# other error (version of conffile missing)
	if [ "$verbose" != "-q" ]; then
		echo "Fehler - Versionspruefung der Konfig-datei von $scriptname nicht moeglich!"
	else
		$errlog check of version of conf file impossible
	fi
	exit 2
else						# check ok, reset $ret
	ret=0
fi

# check arguments after options
case "$opt" in
  "")	if [ "$#" -eq 1 ]; then			# parameter count ok
				arg1="$1"
				#shift
		else				# error in param count
			if [ "$verbose" != "-q" ]; then
				echo "Fehler - Parameteranzahl falsch!" >&2
			else
				$errlog parameter count wrong
			fi
			exit 1
		fi;;
#  *)	if [ "$#" -ne 0 ]; then			# error in param count
#		if [ "$verbose" != "-q" ]; then
#			echo "Fehler - Parameteranzahl falsch!" >&2
#		else
#			$errlog parameter count
#		fi
#		exit 1
#	fi;;
esac
##############################################################################
# MAINPROGRAM

if [ "$debug" == "yes" ]; then				# debug
	echo "DEBUG Main: $# $@" >&2
	#$debuglog Main: $# $@
fi

# Check what to do (initial options and args are removed from cmdline)
case "$opt" in
  "")	main_proc $arg1					# no opt given
	err=$?;;
esac

exit $err
